Synnefo - Feature # 447

Status: Closed Priority: High

Author: Giorgos Verigakis Category: Pithos

Created: 04/28/2011 Assignee: Antony Chazapis
Updated: 02/08/2013 Due date:

Subject: Implement a "dummy" local backend

Description

Needed to support the API. It can store data in files in the filesystem and use an sqlite for the namespace mapping.

Associated revisions

Revision b3e83caa - 04/28/2011 08:53 pm - Sofia Papagiannaki

Jetatpor oe class, include accounts
Refs #447

Revision b3e83caa - 04/28/2011 08:53 pm - papagian

petatpor o€ class, include accounts
Refs #447

Revision 24484999 - 04/28/2011 09:18 pm - Sofia Papagiannaki

create account when create container if not exists
Refs #447

Revision 24484999 - 04/28/2011 09:18 pm - papagian

create account when create container if not exists

Refs #447

Revision 59d6bd1e - 04/28/2011 09:38 pm - Sofia Papagiannaki

Fixes #447

Revision 59d6bd1e - 04/28/2011 09:38 pm - papagian

Fixes #447

Revision 6a820623 - 04/28/2011 09:58 pm - Sofia Papagiannaki

Fixes #447
Revision 6a820623 - 04/28/2011 09:58 pm - papagian

Fixes #447

Revision ada7df10 - 04/29/2011 04:46 pm - Sofia Papagiannaki

list_objects changes
Fixes #447

Revision ada7df10 - 04/29/2011 04:46 pm - papagian

list_objects changes
Fixes #447

Revision 4943ab27 - 05/02/2011 02:27 pm - Sofia Papagiannaki

Refs #447

Revision 4943ab27 - 05/02/2011 02:27 pm - papagian

Refs #447

Revision 793c91d1 - 05/02/2011 05:22 pm - Sofia Papagiannaki

Refs #447

Revision 793c91d1 - 05/02/2011 05:22 pm - papagian

Refs #447

Revision 83894828 - 05/03/2011 04:40 pm - Sofia Papagiannaki

metadata dict accepts non string values
Refs #447

Revision 83894828 - 05/03/2011 04:40 pm - papagian

metadata dict accepts non string values

Refs #447

Revision d1578725 - 05/05/2011 11:38 am - Sofia Papagiannaki

Fixes #447
Revision d1578725 - 05/05/2011 11:38 am - papagian

Fixes #447

Revision 8b4591b4 - 05/05/2011 12:56 pm - Sofia Papagiannaki

Fixes #447

Revision 8b4591b4 - 05/05/2011 12:56 pm - papagian

Fixes #447

Revision 442b2e44 - 05/05/2011 06:50 pm - Sofia Papagiannaki

#Refs #447

Revision 3b3c31c6 - 05/05/2011 06:51 pm - Sofia Papagiannaki

Refs #447

Revision 3b3c31c6 - 05/05/2011 06:51 pm - papagian

Refs #447

Revision b956618e - 05/17/2011 06:41 pm - Antony Chazapis

Implement basic functionality plus some extras

The APl is based on the Apr. 15, 2011 release of the OpenStack Object Storage API v1.
The implementation is broken up into two layers - frontend (API) and backend (data and metadata handling).
The APl is documented in the wiki. The following list is copied here for reference.
List of differences from the OOS API and clarifications:

- Authentication is done by another system. The token is used in the same way, but it is obtained differently. The top level GET request is kept
compatible with the OOS API and allows for guest/testing operations.

- Support for X-Account-Meta-* style headers at the account level. Use POST to update.

- Support for X-Container-Meta-* style headers at the account level. Can be set when creating via PUT. Use POST to update.

- Some processing is done in the variable part of all X-*-Meta-* headers. If it includes underscores, they will be converted to dashes and the first letter of
all intra-dash strings will be capitalized.

- All metadata replies, at all levels, include latest modification information.

- Atall levels, a GET request may use If-Modified-Since and If-Unmodified-Since headers.

- A GET reply for a level will include all headers of the corresponding HEAD request.

- To avoid conflicts between objects and virtual directory markers in container listings, it is recommended that object names do not end with the
delimiter used.

- The Accept header may be used in requests instead of the format parameter to specify the desired reply format. The parameter overrides the header.

- Container/object lists use a 200 return code if the reply is of type json/xml. The reply will include an empty json/xml.

- Container/object lists include all associated metadata if the reply is of type json/xml. Some names are kept to their OOS API equivalents for
compatibility.
- In headers, dates are formatted according to RFC 1123. In extended information listings, dates are formatted according to ISO 8601.
- Object headers allowed, in addition to X-Object-Meta-*: Content-Encoding
- Object MOVE support.

Fixes #445
Fixes #447
Fixes #445
Fixes #447

History

#1 - 04/28/2011 02:08 pm - Giorgos Verigakis
- Tracker changed from Bug to Feature

#2 - 04/28/2011 06:20 pm - Giorgos Verigakis
- Target version set to 0.1

#3 - 05/17/2011 08:02 pm - Giorgos Verigakis
- Status changed from New to Closed
- Assignee changed from Sofia Papagiannaki to Antony Chazapis

The backend is called SimpleBackend.
#4 - 02/08/2013 07:01 pm - Vangelis Koukis
- Project changed from Pithos to Synnefo
- Target version deleted (0.1)

#5 - 02/08/2013 07:03 pm - Vangelis Koukis
- Category set to Pithos

04/20/2024

5/5



